io.vertx.ext.web.handler

## Interface CSPHandler

- All Superinterfaces:
    Handler<RoutingContext>

      public interface CSPHandler
      extends Handler<RoutingContext>

  Content Security Policy (CSP) is an added layer of security that helps to detect and mitigate certain types of attacks, including Cross Site Scripting (XSS) and data injection attacks. These attacks are used for everything from data theft to site defacement to distribution of malware. CSP is designed to be fully backward compatible. Browsers that don't support it still work with servers that implement it, and vice-versa: browsers that don't support CSP simply ignore it, functioning as usual, defaulting to the standard same-origin policy for web content. If the site doesn't offer the CSP header, browsers likewise use the standard same-origin policy.

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `CSPHandler` | `addDirective(String name, String value)` Adds a single directive entry to the handler.
    `static CSPHandler` | `create()` Creates a new instance of the handler.
    `CSPHandler` | `setDirective(String name, String value)` Sets a single directive entry to the handler.
    `CSPHandler` | `setReportOnly(boolean reportOnly)` To ease deployment, CSP can be deployed in report-only mode.

    - ### Methods inherited from interface io.vertx.core.Handler

      `handle`

- - ### Method Detail

    - #### create

          static CSPHandler create()

      Creates a new instance of the handler.
      Returns:
        a new CSP handler.

    - #### setDirective

          CSPHandler setDirective(String name,
                                  String value)

      Sets a single directive entry to the handler. All previously set or added directives will be replaced. For more information on directives see: Content-Security-Policy.
      Parameters:
        `name` - the directive name
        `value` - the directive value.
      Returns:
        fluent self

    - #### addDirective

          CSPHandler addDirective(String name,
                                  String value)

      Adds a single directive entry to the handler. All previously set or added directives will be preserved. For more information on directives see: Content-Security-Policy.
      Parameters:
        `name` - the directive name
        `value` - the directive value.
      Returns:
        fluent self

    - #### setReportOnly

          CSPHandler setReportOnly(boolean reportOnly)

      To ease deployment, CSP can be deployed in report-only mode. The policy is not enforced, but any violations are reported to a provided URI. Additionally, a report-only header can be used to test a future revision to a policy without actually deploying it.
      Parameters:
        `reportOnly` - enable report only
      Returns:
        fluent self.

Copyright © 2021 Eclipse. All rights reserved.